Public Class DigiSign
	Inherits AsymCrypt

	Public Sub New(ByVal p_KeySize As KeySize)

		MyBase.New(p_KeySize)

	End Sub

	Public Overrides Function Crypt(ByVal p_strCrypt As String) As String
		Dim MD5Hash As Cryptography.MD5CryptoServiceProvider
		MD5Hash = New Cryptography.MD5CryptoServiceProvider()

		Return Convert.ToBase64String(MyBase.RSAKey.SignData(Convert.FromBase64String(p_strCrypt), MD5Hash))

		MD5Hash.Clear()
		MD5Hash = Nothing

	End Function

	Public Function Verify(ByVal p_strMessage As String, ByVal p_strSignature As String) As Boolean
		Dim MD5Hash As Cryptography.MD5CryptoServiceProvider
		MD5Hash = New Cryptography.MD5CryptoServiceProvider()

		Return MyBase.RSAKey.VerifyData(Convert.FromBase64String(p_strMessage), MD5Hash, Convert.FromBase64String(p_strSignature))

		MD5Hash.Clear()
		MD5Hash = Nothing

	End Function

End Class
