Public Class SymEnCrypt
	Inherits SymCrypt

	Public Sub New(ByVal p_KeyAlgorithm As CryptoAlgorithm, _
	ByVal p_CipherMode As Cryptography.CipherMode, _
	ByVal p_PaddingMode As Cryptography.PaddingMode, _
	ByVal p_KeySize As DESKeySize)

		MyBase.new(p_KeyAlgorithm, p_CipherMode, p_PaddingMode, p_KeySize)

	End Sub

	Public Sub New(ByVal p_KeyAlgorithm As CryptoAlgorithm, _
	ByVal p_CipherMode As Cryptography.CipherMode, _
	ByVal p_PaddingMode As Cryptography.PaddingMode, _
	ByVal p_KeySize As RC2KeySize)

		MyBase.new(p_KeyAlgorithm, p_CipherMode, p_PaddingMode, p_KeySize)


	End Sub

	Public Sub New(ByVal p_KeyAlgorithm As CryptoAlgorithm, _
	ByVal p_CipherMode As Cryptography.CipherMode, _
	ByVal p_PaddingMode As Cryptography.PaddingMode, _
	ByVal p_KeySize As RijndaelKeySize)

		MyBase.new(p_KeyAlgorithm, p_CipherMode, p_PaddingMode, p_KeySize)

	End Sub


	Public Sub New(ByVal p_KeyAlgorithm As CryptoAlgorithm, _
	ByVal p_CipherMode As Cryptography.CipherMode, _
	ByVal p_PaddingMode As Cryptography.PaddingMode, _
	ByVal p_KeySize As TripleDESKeySize)

		MyBase.new(p_KeyAlgorithm, p_CipherMode, p_PaddingMode, p_KeySize)

	End Sub

	Public Overrides Function Crypt(ByVal p_strCrypt As String) As String

		Dim bytBlock As Byte()
		Dim bytEBlock As Byte()
		Dim Memory As IO.MemoryStream
		Dim CryptoMemory As Cryptography.CryptoStream

		bytBlock = Encoding.UTF8.GetBytes(p_strCrypt)

		Memory = New IO.MemoryStream()
		CryptoMemory = New Cryptography.CryptoStream(Memory, MyBase.CryptoKey.CreateEncryptor(), Cryptography.CryptoStreamMode.Write)

		CryptoMemory.Write(bytBlock, 0, bytBlock.Length)
		CryptoMemory.FlushFinalBlock()

		bytEBlock = Memory.ToArray()

		Memory.Close()
		Memory = Nothing
		CryptoMemory.Close()
		CryptoMemory = Nothing

		Return Convert.ToBase64String(bytEBlock)

	End Function
End Class
